<center><a href="ex94.c">Actual source code: ex94.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:26:33+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80">
<a name="line2">  2: </a>static char help[] = <font color="#666666">"Tests sequential and parallel <A href="../../../../docs/manualpages/Mat/MatMatMult.html#MatMatMult">MatMatMult</A>() and <A href="../../../../docs/manualpages/Mat/MatPtAP.html#MatPtAP">MatPtAP</A>(), sequential <A href="../../../../docs/manualpages/Mat/MatMatMultTranspose.html#MatMatMultTranspose">MatMatMultTranspose</A>()\n\</font>
<a name="line3">  3: </a><font color="#666666">Input arguments are:\n\</font>
<a name="line4">  4: </a><font color="#666666">  -f0 &lt;input_file&gt; -f1 &lt;input_file&gt; -f2 &lt;input_file&gt; -f3 &lt;input_file&gt; : file to load\n\n"</font>;
<a name="line5">  5: </a><font color="#B22222">/* e.g., ex94 -f0 $D/small -f1 $D/small -f2 $D/arco1 -f3 $D/arco1 */</font>

<a name="line7"> 7: </a> #include <A href="../../../../include/petscmat.h.html">petscmat.h</A>

<a name="line11"> 11: </a><strong><font color="#4169E1"><a name="main"></a>int main(int argc,char **args)</font></strong>
<a name="line12"> 12: </a>{
<a name="line13"> 13: </a>  <A href="../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>            A,A_save,B,P,C;
<a name="line14"> 14: </a>  <A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>            x,v1,v2;
<a name="line15"> 15: </a>  <A href="../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>    viewer;
<a name="line17"> 17: </a>  <A href="../../../../docs/manualpages/Sys/PetscMPIInt.html#PetscMPIInt">PetscMPIInt</A>    <A href="../../../../docs/manualpages/Sys/size.html#size">size</A>,<A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A>;
<a name="line18"> 18: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,m,n,j,*idxn,M,N,nzp;
<a name="line19"> 19: </a>  <A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      norm,norm_tmp,tol=1.e-8,fill=4.0;
<a name="line20"> 20: </a>  <A href="../../../../docs/manualpages/Sys/PetscRandom.html#PetscRandom">PetscRandom</A>    rdm;
<a name="line21"> 21: </a>  char           file[4][128];
<a name="line22"> 22: </a>  <A href="../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>     flg,preload = <A href="../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>;
<a name="line23"> 23: </a>  <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    *a,rval,alpha,none = -1.0;
<a name="line24"> 24: </a>  <A href="../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>     Test_MatMatMult=<A href="../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>,Test_MatMatMultTr=<A href="../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>;
<a name="line25"> 25: </a>  <A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>            v3,v4,v5;
<a name="line26"> 26: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       pm,pn,pM,pN;
<a name="line27"> 27: </a>  <A href="../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>     Test_MatPtAP=<A href="../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>;

<a name="line29"> 29: </a>  <A href="../../../../docs/manualpages/Sys/PetscInitialize.html#PetscInitialize">PetscInitialize</A>(&amp;argc,&amp;args,(char *)0,help);
<a name="line30"> 30: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_size.html#MPI_Comm_size">MPI_Comm_size</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;<A href="../../../../docs/manualpages/Sys/size.html#size">size</A>);
<a name="line31"> 31: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_rank.html#MPI_Comm_rank">MPI_Comm_rank</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;<A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A>);

<a name="line33"> 33: </a>  <font color="#B22222">/*  Load the matrices A and B */</font>
<a name="line34"> 34: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsGetString.html#PetscOptionsGetString">PetscOptionsGetString</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-f0"</font>,file[0],127,&amp;flg);
<a name="line35"> 35: </a>  <font color="#4169E1">if</font> (!flg) <A href="../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(1,<font color="#666666">"Must indicate a file name for small matrix A with the -f0 option."</font>);
<a name="line36"> 36: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsGetString.html#PetscOptionsGetString">PetscOptionsGetString</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-f1"</font>,file[1],127,&amp;flg);
<a name="line37"> 37: </a>  <font color="#4169E1">if</font> (!flg) <A href="../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(1,<font color="#666666">"Must indicate a file name for small matrix B with the -f1 option."</font>);
<a name="line38"> 38: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsGetString.html#PetscOptionsGetString">PetscOptionsGetString</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-f2"</font>,file[2],127,&amp;flg);
<a name="line39"> 39: </a>  <font color="#4169E1">if</font> (!flg) {
<a name="line40"> 40: </a>    preload = <A href="../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>;
<a name="line41"> 41: </a>  } <font color="#4169E1">else</font> {
<a name="line42"> 42: </a>    <A href="../../../../docs/manualpages/Sys/PetscOptionsGetString.html#PetscOptionsGetString">PetscOptionsGetString</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-f3"</font>,file[3],127,&amp;flg);
<a name="line43"> 43: </a>    <font color="#4169E1">if</font> (!flg) <A href="../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(1,<font color="#666666">"Must indicate a file name for test matrix B with the -f3 option."</font>);
<a name="line44"> 44: </a>  }

<a name="line46"> 46: </a>  <A href="../../../../docs/manualpages/Profiling/PreLoadBegin.html#PreLoadBegin">PreLoadBegin</A>(preload,<font color="#666666">"Load system"</font>);
<a name="line47"> 47: </a>  <A href="../../../../docs/manualpages/Viewer/PetscViewerBinaryOpen.html#PetscViewerBinaryOpen">PetscViewerBinaryOpen</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,file[2*PreLoadIt],FILE_MODE_READ,&amp;viewer);
<a name="line48"> 48: </a>  <A href="../../../../docs/manualpages/Mat/MatLoad.html#MatLoad">MatLoad</A>(viewer,<A href="../../../../docs/manualpages/Mat/MATAIJ.html#MATAIJ">MATAIJ</A>,&amp;A_save);
<a name="line49"> 49: </a>  <A href="../../../../docs/manualpages/Viewer/PetscViewerDestroy.html#PetscViewerDestroy">PetscViewerDestroy</A>(viewer);

<a name="line51"> 51: </a>  <A href="../../../../docs/manualpages/Viewer/PetscViewerBinaryOpen.html#PetscViewerBinaryOpen">PetscViewerBinaryOpen</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,file[2*PreLoadIt+1],FILE_MODE_READ,&amp;viewer);
<a name="line52"> 52: </a>  <A href="../../../../docs/manualpages/Mat/MatLoad.html#MatLoad">MatLoad</A>(viewer,<A href="../../../../docs/manualpages/Mat/MATAIJ.html#MATAIJ">MATAIJ</A>,&amp;B);
<a name="line53"> 53: </a>  <A href="../../../../docs/manualpages/Viewer/PetscViewerDestroy.html#PetscViewerDestroy">PetscViewerDestroy</A>(viewer);

<a name="line55"> 55: </a>  <A href="../../../../docs/manualpages/Mat/MatGetSize.html#MatGetSize">MatGetSize</A>(B,&amp;M,&amp;N);
<a name="line56"> 56: </a>  nzp  = (<A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>)(0.1*M);
<a name="line57"> 57: </a>  <A href="../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((nzp+1)*(<font color="#4169E1">sizeof</font>(<A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>)+<font color="#4169E1">sizeof</font>(<A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>)),&amp;idxn);
<a name="line58"> 58: </a>  a    = (<A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>*)(idxn + nzp);
<a name="line59"> 59: </a>
<a name="line60"> 60: </a>  <font color="#B22222">/* Create vectors v1 and v2 that are compatible with A_save */</font>
<a name="line61"> 61: </a>  <A href="../../../../docs/manualpages/Vec/VecCreate.html#VecCreate">VecCreate</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;v1);
<a name="line62"> 62: </a>  <A href="../../../../docs/manualpages/Mat/MatGetLocalSize.html#MatGetLocalSize">MatGetLocalSize</A>(A_save,&amp;m,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line63"> 63: </a>  <A href="../../../../docs/manualpages/Vec/VecSetSizes.html#VecSetSizes">VecSetSizes</A>(v1,m,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>);
<a name="line64"> 64: </a>  <A href="../../../../docs/manualpages/Vec/VecSetFromOptions.html#VecSetFromOptions">VecSetFromOptions</A>(v1);
<a name="line65"> 65: </a>  <A href="../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(v1,&amp;v2);

<a name="line67"> 67: </a>  <A href="../../../../docs/manualpages/Sys/PetscRandomCreate.html#PetscRandomCreate">PetscRandomCreate</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;rdm);
<a name="line68"> 68: </a>  <A href="../../../../docs/manualpages/Sys/PetscRandomSetFromOptions.html#PetscRandomSetFromOptions">PetscRandomSetFromOptions</A>(rdm);
<a name="line69"> 69: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsGetReal.html#PetscOptionsGetReal">PetscOptionsGetReal</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-fill"</font>,&amp;fill,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);

<a name="line71"> 71: </a>  <font color="#B22222">/* Test <A href="../../../../docs/manualpages/Mat/MatMatMult.html#MatMatMult">MatMatMult</A>() */</font>
<a name="line72"> 72: </a>  <font color="#B22222">/*-------------------*/</font>
<a name="line73"> 73: </a>  <font color="#4169E1">if</font> (Test_MatMatMult){
<a name="line74"> 74: </a>    <A href="../../../../docs/manualpages/Mat/MatDuplicate.html#MatDuplicate">MatDuplicate</A>(A_save,MAT_COPY_VALUES,&amp;A);
<a name="line75"> 75: </a>    <A href="../../../../docs/manualpages/Mat/MatMatMult.html#MatMatMult">MatMatMult</A>(A,B,MAT_INITIAL_MATRIX,fill,&amp;C);
<a name="line76"> 76: </a>
<a name="line77"> 77: </a>    <font color="#B22222">/* Test MAT_REUSE_MATRIX - reuse symbolic C */</font>
<a name="line78"> 78: </a>    alpha=1.0;
<a name="line79"> 79: </a>    <font color="#4169E1">for</font> (i=0; i&lt;2; i++){
<a name="line80"> 80: </a>      alpha -=0.1;
<a name="line81"> 81: </a>      <A href="../../../../docs/manualpages/Mat/MatScale.html#MatScale">MatScale</A>(A,alpha);
<a name="line82"> 82: </a>      <A href="../../../../docs/manualpages/Mat/MatMatMult.html#MatMatMult">MatMatMult</A>(A,B,MAT_REUSE_MATRIX,fill,&amp;C);
<a name="line83"> 83: </a>    }
<a name="line84"> 84: </a>
<a name="line85"> 85: </a>    <font color="#B22222">/* Create vector x that is compatible with B */</font>
<a name="line86"> 86: </a>    <A href="../../../../docs/manualpages/Vec/VecCreate.html#VecCreate">VecCreate</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;x);
<a name="line87"> 87: </a>    <A href="../../../../docs/manualpages/Mat/MatGetLocalSize.html#MatGetLocalSize">MatGetLocalSize</A>(B,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,&amp;n);
<a name="line88"> 88: </a>    <A href="../../../../docs/manualpages/Vec/VecSetSizes.html#VecSetSizes">VecSetSizes</A>(x,n,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>);
<a name="line89"> 89: </a>    <A href="../../../../docs/manualpages/Vec/VecSetFromOptions.html#VecSetFromOptions">VecSetFromOptions</A>(x);

<a name="line91"> 91: </a>    norm = 0.0;
<a name="line92"> 92: </a>    <font color="#4169E1">for</font> (i=0; i&lt;10; i++) {
<a name="line93"> 93: </a>      <A href="../../../../docs/manualpages/Vec/VecSetRandom.html#VecSetRandom">VecSetRandom</A>(x,rdm);
<a name="line94"> 94: </a>      <A href="../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A>(B,x,v1);
<a name="line95"> 95: </a>      <A href="../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A>(A,v1,v2);  <font color="#B22222">/* v2 = A*B*x */</font>
<a name="line96"> 96: </a>      <A href="../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A>(C,x,v1);   <font color="#B22222">/* v1 = C*x   */</font>
<a name="line97"> 97: </a>      <A href="../../../../docs/manualpages/Vec/VecAXPY.html#VecAXPY">VecAXPY</A>(v1,none,v2);
<a name="line98"> 98: </a>      <A href="../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(v1,<A href="../../../../docs/manualpages/Vec/NORM_2.html#NORM_2">NORM_2</A>,&amp;norm_tmp);
<a name="line99"> 99: </a>      <font color="#4169E1">if</font> (norm_tmp &gt; norm) norm = norm_tmp;
<a name="line100">100: </a>    }
<a name="line101">101: </a>    <font color="#4169E1">if</font> (norm &gt;= tol) {
<a name="line102">102: </a>      <A href="../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,<font color="#666666">"Error: <A href="../../../../docs/manualpages/Mat/MatMatMult.html#MatMatMult">MatMatMult</A>(), |v1 - v2|: %G\n"</font>,norm);
<a name="line103">103: </a>    }
<a name="line104">104: </a>    <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(A);
<a name="line105">105: </a>    <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(C);
<a name="line106">106: </a>    <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(x);
<a name="line107">107: </a>  } <font color="#B22222">/* if (Test_MatMatMult) */</font>

<a name="line109">109: </a>  <font color="#B22222">/* Test <A href="../../../../docs/manualpages/Mat/MatMatMultTranspose.html#MatMatMultTranspose">MatMatMultTranspose</A>() */</font>
<a name="line110">110: </a>  <font color="#B22222">/*----------------------------*/</font>
<a name="line111">111: </a>  <font color="#4169E1">if</font> (<A href="../../../../docs/manualpages/Sys/size.html#size">size</A>&gt;1) Test_MatMatMultTr = <A href="../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>;
<a name="line112">112: </a>  <font color="#4169E1">if</font> (Test_MatMatMultTr){
<a name="line113">113: </a>    <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> PN;
<a name="line114">114: </a>    <font color="#B22222">/* <A href="../../../../docs/manualpages/Mat/MatGetSize.html#MatGetSize">MatGetSize</A>(B,&amp;M,&amp;N); */</font>
<a name="line115">115: </a>    PN   = M/2;
<a name="line116">116: </a>    nzp  = 5; <font color="#B22222">/* num of nonzeros in each row of P */</font>
<a name="line117">117: </a>    <A href="../../../../docs/manualpages/Mat/MatCreate.html#MatCreate">MatCreate</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;P);
<a name="line118">118: </a>    <A href="../../../../docs/manualpages/Mat/MatSetSizes.html#MatSetSizes">MatSetSizes</A>(P,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,M,PN);
<a name="line119">119: </a>    <A href="../../../../docs/manualpages/Mat/MatSetType.html#MatSetType">MatSetType</A>(P,<A href="../../../../docs/manualpages/Mat/MATAIJ.html#MATAIJ">MATAIJ</A>);
<a name="line120">120: </a>    <A href="../../../../docs/manualpages/Mat/MatSeqAIJSetPreallocation.html#MatSeqAIJSetPreallocation">MatSeqAIJSetPreallocation</A>(P,nzp,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line121">121: </a>    <A href="../../../../docs/manualpages/Mat/MatMPIAIJSetPreallocation.html#MatMPIAIJSetPreallocation">MatMPIAIJSetPreallocation</A>(P,nzp,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,nzp,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line122">122: </a>    <font color="#4169E1">for</font> (i=0; i&lt;nzp; i++){
<a name="line123">123: </a>      <A href="../../../../docs/manualpages/Sys/PetscRandomGetValue.html#PetscRandomGetValue">PetscRandomGetValue</A>(rdm,&amp;a[i]);
<a name="line124">124: </a>    }
<a name="line125">125: </a>    <font color="#4169E1">for</font> (i=0; i&lt;M; i++){
<a name="line126">126: </a>      <font color="#4169E1">for</font> (j=0; j&lt;nzp; j++){
<a name="line127">127: </a>        <A href="../../../../docs/manualpages/Sys/PetscRandomGetValue.html#PetscRandomGetValue">PetscRandomGetValue</A>(rdm,&amp;rval);
<a name="line128">128: </a>        idxn[j] = (<A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>)(PetscRealPart(rval)*PN);
<a name="line129">129: </a>      }
<a name="line130">130: </a>      <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(P,1,&amp;i,nzp,idxn,a,<A href="../../../../docs/manualpages/Sys/ADD_VALUES.html#ADD_VALUES">ADD_VALUES</A>);
<a name="line131">131: </a>    }
<a name="line132">132: </a>    <A href="../../../../docs/manualpages/Mat/MatAssemblyBegin.html#MatAssemblyBegin">MatAssemblyBegin</A>(P,MAT_FINAL_ASSEMBLY);
<a name="line133">133: </a>    <A href="../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>(P,MAT_FINAL_ASSEMBLY);
<a name="line134">134: </a>
<a name="line135">135: </a>    <A href="../../../../docs/manualpages/Mat/MatMatMultTranspose.html#MatMatMultTranspose">MatMatMultTranspose</A>(P,B,MAT_INITIAL_MATRIX,fill,&amp;C);

<a name="line137">137: </a>    <font color="#B22222">/* Test MAT_REUSE_MATRIX - reuse symbolic C */</font>
<a name="line138">138: </a>    alpha=1.0;
<a name="line139">139: </a>    <font color="#4169E1">for</font> (i=0; i&lt;2; i++){
<a name="line140">140: </a>      alpha -=0.1;
<a name="line141">141: </a>      <A href="../../../../docs/manualpages/Mat/MatScale.html#MatScale">MatScale</A>(P,alpha);
<a name="line142">142: </a>      <A href="../../../../docs/manualpages/Mat/MatMatMultTranspose.html#MatMatMultTranspose">MatMatMultTranspose</A>(P,B,MAT_REUSE_MATRIX,fill,&amp;C);
<a name="line143">143: </a>    }

<a name="line145">145: </a>    <font color="#B22222">/* Create vector x, v5 that are compatible with B */</font>
<a name="line146">146: </a>    <A href="../../../../docs/manualpages/Vec/VecCreate.html#VecCreate">VecCreate</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;x);
<a name="line147">147: </a>    <A href="../../../../docs/manualpages/Mat/MatGetLocalSize.html#MatGetLocalSize">MatGetLocalSize</A>(B,&amp;m,&amp;n);
<a name="line148">148: </a>    <A href="../../../../docs/manualpages/Vec/VecSetSizes.html#VecSetSizes">VecSetSizes</A>(x,n,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>);
<a name="line149">149: </a>    <A href="../../../../docs/manualpages/Vec/VecSetFromOptions.html#VecSetFromOptions">VecSetFromOptions</A>(x);

<a name="line151">151: </a>    <A href="../../../../docs/manualpages/Vec/VecCreate.html#VecCreate">VecCreate</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;v5);
<a name="line152">152: </a>    <A href="../../../../docs/manualpages/Vec/VecSetSizes.html#VecSetSizes">VecSetSizes</A>(v5,m,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>);
<a name="line153">153: </a>    <A href="../../../../docs/manualpages/Vec/VecSetFromOptions.html#VecSetFromOptions">VecSetFromOptions</A>(v5);
<a name="line154">154: </a>
<a name="line155">155: </a>    <A href="../../../../docs/manualpages/Mat/MatGetLocalSize.html#MatGetLocalSize">MatGetLocalSize</A>(P,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,&amp;n);
<a name="line156">156: </a>    <A href="../../../../docs/manualpages/Vec/VecCreate.html#VecCreate">VecCreate</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;v3);
<a name="line157">157: </a>    <A href="../../../../docs/manualpages/Vec/VecSetSizes.html#VecSetSizes">VecSetSizes</A>(v3,n,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>);
<a name="line158">158: </a>    <A href="../../../../docs/manualpages/Vec/VecSetFromOptions.html#VecSetFromOptions">VecSetFromOptions</A>(v3);
<a name="line159">159: </a>    <A href="../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(v3,&amp;v4);

<a name="line161">161: </a>    norm = 0.0;
<a name="line162">162: </a>    <font color="#4169E1">for</font> (i=0; i&lt;10; i++) {
<a name="line163">163: </a>      <A href="../../../../docs/manualpages/Vec/VecSetRandom.html#VecSetRandom">VecSetRandom</A>(x,rdm);
<a name="line164">164: </a>      <A href="../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A>(B,x,v5);            <font color="#B22222">/* v5 = B*x   */</font>
<a name="line165">165: </a>      <A href="../../../../docs/manualpages/Mat/MatMultTranspose.html#MatMultTranspose">MatMultTranspose</A>(P,v5,v3);  <font color="#B22222">/* v3 = Pt*B*x */</font>
<a name="line166">166: </a>      <A href="../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A>(C,x,v4);            <font color="#B22222">/* v4 = C*x   */</font>
<a name="line167">167: </a>      <A href="../../../../docs/manualpages/Vec/VecAXPY.html#VecAXPY">VecAXPY</A>(v4,none,v3);
<a name="line168">168: </a>      <A href="../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(v4,<A href="../../../../docs/manualpages/Vec/NORM_2.html#NORM_2">NORM_2</A>,&amp;norm_tmp);
<a name="line169">169: </a>      <font color="#4169E1">if</font> (norm_tmp &gt; norm) norm = norm_tmp;
<a name="line170">170: </a>    }
<a name="line171">171: </a>    <font color="#4169E1">if</font> (norm &gt;= tol) {
<a name="line172">172: </a>      <A href="../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,<font color="#666666">"Error: MatMatMultTr(), |v3 - v4|: %G\n"</font>,norm);
<a name="line173">173: </a>    }
<a name="line174">174: </a>    <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(P);
<a name="line175">175: </a>    <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(C);
<a name="line176">176: </a>    <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(v3);
<a name="line177">177: </a>    <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(v4);
<a name="line178">178: </a>    <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(v5);
<a name="line179">179: </a>    <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(x);
<a name="line180">180: </a>  }

<a name="line182">182: </a>  <font color="#B22222">/* Test <A href="../../../../docs/manualpages/Mat/MatPtAP.html#MatPtAP">MatPtAP</A>() */</font>
<a name="line183">183: </a>  <font color="#B22222">/*----------------------*/</font>
<a name="line184">184: </a>  <font color="#4169E1">if</font> (Test_MatPtAP){
<a name="line185">185: </a>    <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> PN;
<a name="line186">186: </a>    <A href="../../../../docs/manualpages/Mat/MatDuplicate.html#MatDuplicate">MatDuplicate</A>(A_save,MAT_COPY_VALUES,&amp;A);
<a name="line187">187: </a>    <A href="../../../../docs/manualpages/Mat/MatGetSize.html#MatGetSize">MatGetSize</A>(A,&amp;M,&amp;N);
<a name="line188">188: </a>    <A href="../../../../docs/manualpages/Mat/MatGetLocalSize.html#MatGetLocalSize">MatGetLocalSize</A>(A,&amp;m,&amp;n);
<a name="line189">189: </a>    <font color="#B22222">/* <A href="../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,"[%d] A: %d,%d, %d,%d\n",<A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A>,m,n,M,N); */</font>

<a name="line191">191: </a>    PN   = M/2;
<a name="line192">192: </a>    nzp  = (<A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>)(0.1*PN); <font color="#B22222">/* num of nozeros in each row of P */</font>
<a name="line193">193: </a>    <A href="../../../../docs/manualpages/Mat/MatCreate.html#MatCreate">MatCreate</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;P);
<a name="line194">194: </a>    <A href="../../../../docs/manualpages/Mat/MatSetSizes.html#MatSetSizes">MatSetSizes</A>(P,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,N,PN);
<a name="line195">195: </a>    <A href="../../../../docs/manualpages/Mat/MatSetType.html#MatSetType">MatSetType</A>(P,<A href="../../../../docs/manualpages/Mat/MATAIJ.html#MATAIJ">MATAIJ</A>);
<a name="line196">196: </a>    <A href="../../../../docs/manualpages/Mat/MatSeqAIJSetPreallocation.html#MatSeqAIJSetPreallocation">MatSeqAIJSetPreallocation</A>(P,nzp,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line197">197: </a>    <A href="../../../../docs/manualpages/Mat/MatMPIAIJSetPreallocation.html#MatMPIAIJSetPreallocation">MatMPIAIJSetPreallocation</A>(P,nzp,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,nzp,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line198">198: </a>    <font color="#4169E1">for</font> (i=0; i&lt;nzp; i++){
<a name="line199">199: </a>      <A href="../../../../docs/manualpages/Sys/PetscRandomGetValue.html#PetscRandomGetValue">PetscRandomGetValue</A>(rdm,&amp;a[i]);
<a name="line200">200: </a>    }
<a name="line201">201: </a>    <font color="#4169E1">for</font> (i=0; i&lt;M; i++){
<a name="line202">202: </a>      <font color="#4169E1">for</font> (j=0; j&lt;nzp; j++){
<a name="line203">203: </a>        <A href="../../../../docs/manualpages/Sys/PetscRandomGetValue.html#PetscRandomGetValue">PetscRandomGetValue</A>(rdm,&amp;rval);
<a name="line204">204: </a>        idxn[j] = (<A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>)(PetscRealPart(rval)*PN);
<a name="line205">205: </a>      }
<a name="line206">206: </a>      <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(P,1,&amp;i,nzp,idxn,a,<A href="../../../../docs/manualpages/Sys/ADD_VALUES.html#ADD_VALUES">ADD_VALUES</A>);
<a name="line207">207: </a>    }
<a name="line208">208: </a>    <A href="../../../../docs/manualpages/Mat/MatAssemblyBegin.html#MatAssemblyBegin">MatAssemblyBegin</A>(P,MAT_FINAL_ASSEMBLY);
<a name="line209">209: </a>    <A href="../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>(P,MAT_FINAL_ASSEMBLY);

<a name="line211">211: </a>    <font color="#B22222">/* <A href="../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A>(P,<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_WORLD.html#PETSC_VIEWER_STDOUT_WORLD">PETSC_VIEWER_STDOUT_WORLD</A>); */</font>
<a name="line212">212: </a>    <A href="../../../../docs/manualpages/Mat/MatGetSize.html#MatGetSize">MatGetSize</A>(P,&amp;pM,&amp;pN);
<a name="line213">213: </a>    <A href="../../../../docs/manualpages/Mat/MatGetLocalSize.html#MatGetLocalSize">MatGetLocalSize</A>(P,&amp;pm,&amp;pn);
<a name="line214">214: </a>    <font color="#B22222">/* <A href="../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>," [%d] P, %d, %d, %d,%d\n",<A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A>,pm,pn,pM,pN); */</font>
<a name="line215">215: </a>    <A href="../../../../docs/manualpages/Mat/MatPtAP.html#MatPtAP">MatPtAP</A>(A,P,MAT_INITIAL_MATRIX,fill,&amp;C);

<a name="line217">217: </a>    <font color="#B22222">/* Test MAT_REUSE_MATRIX - reuse symbolic C */</font>
<a name="line218">218: </a>    alpha=1.0;
<a name="line219">219: </a>    <font color="#4169E1">for</font> (i=0; i&lt;2; i++){
<a name="line220">220: </a>      alpha -=0.1;
<a name="line221">221: </a>      <A href="../../../../docs/manualpages/Mat/MatScale.html#MatScale">MatScale</A>(A,alpha);
<a name="line222">222: </a>      <A href="../../../../docs/manualpages/Mat/MatPtAP.html#MatPtAP">MatPtAP</A>(A,P,MAT_REUSE_MATRIX,fill,&amp;C);
<a name="line223">223: </a>    }

<a name="line225">225: </a>    <font color="#B22222">/* Create vector x that is compatible with P */</font>
<a name="line226">226: </a>    <A href="../../../../docs/manualpages/Vec/VecCreate.html#VecCreate">VecCreate</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;x);
<a name="line227">227: </a>    <A href="../../../../docs/manualpages/Mat/MatGetLocalSize.html#MatGetLocalSize">MatGetLocalSize</A>(P,&amp;m,&amp;n);
<a name="line228">228: </a>    <A href="../../../../docs/manualpages/Vec/VecSetSizes.html#VecSetSizes">VecSetSizes</A>(x,n,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>);
<a name="line229">229: </a>    <A href="../../../../docs/manualpages/Vec/VecSetFromOptions.html#VecSetFromOptions">VecSetFromOptions</A>(x);
<a name="line230">230: </a>
<a name="line231">231: </a>    <A href="../../../../docs/manualpages/Vec/VecCreate.html#VecCreate">VecCreate</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;v3);
<a name="line232">232: </a>    <A href="../../../../docs/manualpages/Vec/VecSetSizes.html#VecSetSizes">VecSetSizes</A>(v3,n,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>);
<a name="line233">233: </a>    <A href="../../../../docs/manualpages/Vec/VecSetFromOptions.html#VecSetFromOptions">VecSetFromOptions</A>(v3);
<a name="line234">234: </a>    <A href="../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(v3,&amp;v4);

<a name="line236">236: </a>    norm = 0.0;
<a name="line237">237: </a>    <font color="#4169E1">for</font> (i=0; i&lt;10; i++) {
<a name="line238">238: </a>      <A href="../../../../docs/manualpages/Vec/VecSetRandom.html#VecSetRandom">VecSetRandom</A>(x,rdm);
<a name="line239">239: </a>      <A href="../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A>(P,x,v1);
<a name="line240">240: </a>      <A href="../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A>(A,v1,v2);  <font color="#B22222">/* v2 = A*P*x */</font>

<a name="line242">242: </a>      <A href="../../../../docs/manualpages/Mat/MatMultTranspose.html#MatMultTranspose">MatMultTranspose</A>(P,v2,v3); <font color="#B22222">/* v3 = Pt*A*P*x */</font>
<a name="line243">243: </a>      <A href="../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A>(C,x,v4);           <font color="#B22222">/* v3 = C*x   */</font>
<a name="line244">244: </a>      <A href="../../../../docs/manualpages/Vec/VecAXPY.html#VecAXPY">VecAXPY</A>(v4,none,v3);
<a name="line245">245: </a>      <A href="../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(v4,<A href="../../../../docs/manualpages/Vec/NORM_2.html#NORM_2">NORM_2</A>,&amp;norm_tmp);
<a name="line246">246: </a>      <font color="#4169E1">if</font> (norm_tmp &gt; norm) norm = norm_tmp;
<a name="line247">247: </a>    }
<a name="line248">248: </a>    <font color="#4169E1">if</font> (norm &gt;= tol) {
<a name="line249">249: </a>      <A href="../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,<font color="#666666">"Error: <A href="../../../../docs/manualpages/Mat/MatPtAP.html#MatPtAP">MatPtAP</A>(), |v1 - v2|: %G\n"</font>,norm);
<a name="line250">250: </a>    }
<a name="line251">251: </a>
<a name="line252">252: </a>    <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(A);
<a name="line253">253: </a>    <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(P);
<a name="line254">254: </a>    <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(C);
<a name="line255">255: </a>    <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(v3);
<a name="line256">256: </a>    <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(v4);
<a name="line257">257: </a>    <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(x);
<a name="line258">258: </a>  } <font color="#B22222">/* if (Test_MatPtAP) */</font>

<a name="line260">260: </a>  <font color="#B22222">/* Destroy objects */</font>
<a name="line261">261: </a>  <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(v1);
<a name="line262">262: </a>  <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(v2);
<a name="line263">263: </a>  <A href="../../../../docs/manualpages/Sys/PetscRandomDestroy.html#PetscRandomDestroy">PetscRandomDestroy</A>(rdm);
<a name="line264">264: </a>  <A href="../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(idxn);
<a name="line265">265: </a>
<a name="line266">266: </a>  <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(A_save);
<a name="line267">267: </a>  <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(B);

<a name="line269">269: </a>  <A href="../../../../docs/manualpages/Profiling/PreLoadEnd.html#PreLoadEnd">PreLoadEnd</A>();
<a name="line270">270: </a>  <A href="../../../../docs/manualpages/Sys/PetscFinalize.html#PetscFinalize">PetscFinalize</A>();

<a name="line272">272: </a>  <font color="#4169E1">return</font> 0;
<a name="line273">273: </a>}

</pre>
</body>

</html>
